#include "palmdep.h"
#include "endianutils.h"
#include "pnobridge.h"
#include "oscompat.h"
#include "endianutils.h"
#include "AppRsc.h"
#ifdef __PACE__  
#include "PACEInterface.h"
#else
#include "palmos5.h"
#endif


#include "PNOMain.h"

#include "unzip.h"

UInt32 mStopEmulation=0;

unsigned long Run()
{
	if (g_pnobridge -> flags&BF_UNZIP) {
	/* FtrId has to be passed in g_pnobridge->game_rom*/
		char *ftrptr;
		unzFile zip_file = 0;    	  
	  	unz_file_info unzinfo;     
      	UInt32 left,pnosize,error;
      	UInt8 *pnotarget,*pnobuf = NULL;
      	char *b;

		zip_file = unzOpen((char*)(g_pnobridge -> param1));

		if ( !zip_file ) {			
			//DEBUGS ( "Couldn't find emulation module!" );
			menu_info((char*)(g_pnobridge -> param1));
			return 1;
      	}

		if (unzGetCurrentFileInfo(zip_file, &unzinfo, NULL/*strload*/, 0/*sizeof(strload)*/, NULL, NULL, NULL, NULL)!=UNZ_OK){
	      unzClose (zip_file);  
	      //DEBUGS("Error in zipped format");
	      return 2;
	  	}
      	unzOpenCurrentFile (zip_file);
      	pnosize = unzinfo.uncompressed_size;	 	 	 
		// get pnolet memory
      	error = FtrPtrNew ( CREATORID, (UInt16)(g_pnobridge -> param2), pnosize, (void**) &pnobuf );

      	if ( error || pnobuf == NULL ) {
			//DEBUGS ( "Couldn't allocate enough storage memory for module!" );
			//DEBUGU32 ( pnosize );
			unzCloseCurrentFile (zip_file);
	    	unzClose (zip_file);
			return 3;
    	}
      	left = pnosize;
      	pnotarget = pnobuf;
      	b = (char*)ydk_malloc ( 40000 );
      	while ( left ) {
	  		UInt16 s;
			if ( left > 40000 ) {
		  		s = 40000;
			} else {
	  			s = left;
			}
			unzReadCurrentFile(zip_file,(void*)b, s);			 		
			DmWrite ( pnobuf, pnotarget - pnobuf, b, s );
			pnotarget += s;
			left -= s;
	  	} // while
      	ydk_free ( b );

		unzCloseCurrentFile (zip_file);
      	unzClose (zip_file);
    	    	
    } //else if 
	return 0;
}


/************************************/

void ClearScreen(void)
{
	UInt8 *vr;
	vr=(UInt8*)(g_pnobridge -> vram);
	for (int y=0;y<g_pnobridge -> display_height;y++)
	{
		memset(vr,0,g_pnobridge -> display_width*2);
		vr+=(g_pnobridge -> display_pitch)*2;
	}
}
